<?php

// Version and path to check version
define('DKRETVERSION', "2.7");
define('DKRETURL', "http://diekretzschmars.de/dkretversion.php");

// current version information
$beta = ' ';
function dkretinfo($show='') {
  global $beta;
	switch($show) {
	case 'version' :
    	$info = DKRETVERSION . $beta;
    	break;
    case 'scheme' :
    	$info = bloginfo('template_url') . '/schemes/' . get_option('dkret_scheme');
    	break;
    }
    echo $info;
}

// import integrated Plugins
require(ABSPATH . '/wp-content/themes/' . get_template() .'/blocks/function_helperfunctions.php');

// localisation won't work without
load_plugin_textdomain('dkret','wp-content/themes/' . get_template() . '/languages');

// add javascript to header
add_action('wp_head', 'dkret_addjs', 1);
function dkret_addjs() {
  if (function_exists('wp_enqueue_script')) {
    wp_enqueue_script('jquery');
    wp_enqueue_script('jquery-comments', get_bloginfo('template_directory') .'/ajax/dkret2.js', array('jquery'), '1.1');

    if (get_option( 'dkret_thickbox' ) == 1)  {
      wp_enqueue_script('thickbox', get_bloginfo('template_directory') .'/ajax/thickbox-pack.js', array('jquery'), '3.0.0');
   		echo "\n".'<link rel="stylesheet" type="text/css" media="screen" href="'. get_bloginfo('template_directory') .'/ajax/thickbox.css" />'."\n";
    }
  }
}

// WIDGETS
if ( function_exists( 'register_sidebars' ) ) {
  register_sidebar(array(
    'name'=>'Sidebar: Top',
    'before_widget' => '<div id="%1$s" class="widget %2$s">',
    'after_widget' => '</div>',
    'before_title' => '<h2 class="widget_title">',
    'after_title' => '</h2>',
  ));

  register_sidebar(array(
    'name'=>'Sidebar: Column1',
    'before_widget' => '<div id="%1$s" class="widget %2$s">',
    'after_widget' => '</div>',
    'before_title' => '<h2 class="widget_title">',
    'after_title' => '</h2>',
  ));
  
    register_sidebar(array(
    'name'=>'Sidebar: Column2',
    'before_widget' => '<div id="%1$s" class="widget %2$s">',
    'after_widget' => '</div>',
    'before_title' => '<h2 class="widget_title">',
    'after_title' => '</h2>',
  ));

  register_sidebar(array(
    'name'=>'Sidebar: Bottom',
    'before_widget' => '<div id="%1$s" class="widget %2$s">',
    'after_widget' => '</div>',
    'before_title' => '<h2 class="widget_title">',
    'after_title' => '</h2>',
  ));

  register_sidebar(array(
    'name'=>'Footer: Column1',
    'before_widget' => '<div id="%1$s" class="widget %2$s">',
    'after_widget' => '</div>',
    'before_title' => '<h2 class="widget_title">',
    'after_title' => '</h2>',
  ));

  register_sidebar(array(
    'name'=>'Footer: Column2',
    'before_widget' => '<div id="%1$s" class="widget %2$s">',
    'after_widget' => '</div>',
    'before_title' => '<h2 class="widget_title">',
    'after_title' => '</h2>',
  ));

  register_sidebar(array(
    'name'=>'Footer: Column3',
    'before_widget' => '<div id="%1$s" class="widget %2$s">',
    'after_widget' => '</div>',
    'before_title' => '<h2 class="widget_title">',
    'after_title' => '</h2>',
  ));

  // now have a look for all available additional widgets and activate them
  $widgets_dir = @ dir(ABSPATH . '/wp-content/themes/' . get_template() . '/widgets');
  if ($widgets_dir)
  {
		while(($widgetFile = $widgets_dir->read()) !== false)
		{
			if (!preg_match('|^\.+$|', $widgetFile) && preg_match('|\.php$|', $widgetFile))
				include(ABSPATH . '/wp-content/themes/' . get_template() . '/widgets/' . $widgetFile);
		}
  }

  // some Widgets should be unregistered
  function unregister_problem_widgets() {
    unregister_sidebar_widget('Links');
    unregister_sidebar_widget('Search');
    unregister_sidebar_widget('Meta');
    if ( function_exists( 'get_recent_comments' ) ) {
    unregister_sidebar_widget('Recent Comments');    
    }
  }

  add_action('widgets_init','unregister_problem_widgets');
}

//save changed options
function dkretupdate() {
	if ( !empty($_POST) ) {
		if ( isset($_POST['scheme_file']) ) {
			$scheme_file = $_POST['scheme_file'];
			update_option('dkret_scheme', $scheme_file, '','');
		}
  	if ( isset($_POST['header_text']) ) {
			update_option('dkret_header_text', '1');
		} else {
			update_option('dkret_header_text', '0');
    }
    if ( isset($_POST['show_subnavigation']) ) {
			$sublevel = $_POST['show_subnavigation']; 
      update_option('dkret_header_subnavigation', $sublevel, '', '');
    }
 		if ( isset($_POST['nowreading']) ) {
			update_option('dkret_nowreading', '1');
		} else {
			update_option('dkret_nowreading', '0');
    }    
		if ( isset($_POST['commentsorder']) ) {
			$commentsorder = $_POST['commentsorder'];
			update_option('dkret_commentsorder', $commentsorder, '','');
		}
		if ( isset($_POST['limitcomments']) ) {
			$limitcomments = $_POST['limitcomments'];
			update_option('dkret_limitcomments', $limitcomments, '','');
		}
		if ( isset($_POST['separatecomments']) ) {
			update_option('dkret_separatecomments', '1');
		} else {
			update_option('dkret_separatecomments', '0');
    }
		if ( isset($_POST['showgravatars']) ) {
			update_option('dkret_showgravatars', '1');
		} else {
			update_option('dkret_showgravatars', '0');
    }    
		if ( isset($_POST['userandomfeature']) ) {		
			update_option('dkret_imagerandomfeature', '1');
		} else {
			update_option('dkret_imagerandomfeature', '0');
    }
		if ($_POST['header_picture'] != "") {
			$header_picture = $_POST['header_picture'];
			update_option('dkret_header_picture', $header_picture, '','');
		} 
		if ($_FILES['picture']['name'] != "" && $_FILES['picture']['size'] > 0) {
			$target_path =  ABSPATH . '/wp-content/themes/' . get_template() . '/images/headers/';
      move_uploaded_file($_FILES['picture']['tmp_name'], $target_path.$_FILES['picture']['name']);
			update_option('dkret_header_picture', $_FILES['picture']['name']);
		}
		if ( isset($_POST['thickbox']) ) {
			update_option('dkret_thickbox', '1');
		} else {
			update_option('dkret_thickbox', '0');
    }
	}
}

// if we can't find dKret2 installed lets go ahead and install all the options that run dKret2.  This should run only one more time for all our existing users, then they will just be getting the upgrade function if it exists.
if (!get_option('dkret_installed')) {
  add_option('dkret_installed', DKRETVERSION);
  add_option('dkret_header_text', '1');
  add_option('dkret_header_subnavigation', '3');
  add_option('dkret_nowreading', '1');
  add_option('dkret_commentsorder', '0');
  add_option('dkret_limitcomments', '0');
  add_option('dkret_separatecomments', '1');
  add_option('dkret_showgravatars', '1');
  add_option('dkret_imagerandomfeature', '0');
  add_option('dkret_header_picture', 'dKret2');
  add_option('dkret_thickbox', '1');
}

function dkretuninstall() {
  delete_option('dkret_installed');
  delete_option('dkret_scheme');
  delete_option('dkret_header_text');
  delete_option('dkret_header_subnavigation');
  delete_option('dkret_nowreading');
  delete_option('dkret_commentsorder');
  delete_option('dkret_limitcomments');
  delete_option('dkret_separatecomments');
  delete_option('dkret_showgravatars');
  delete_option('dkret_imagerandomfeature');
  delete_option('dkret_header_picture');
  delete_option('dkret_thickbox');

  // delete options of the dKret2 Widgets
  // delete_option('widget_dkret_about');
  delete_option('widget_dkret_links');
  delete_option('widget_dkret_meta');
  delete_option('widget_dkret_randomquote');
  delete_option('widget_dkret_search');
  delete_option('widget_dkret_tagcloud');
  delete_option('widget_dkret_todo');

  // old options (for all of you who forgot to uninstall your old version!)  
  delete_option('dkret_gallery2');
  delete_option('dkret_dynamicsidebar');
  delete_option('dkret_sidebarnavigation');
  delete_option('dkret_doublecolumn');
  delete_option('dkret_linkcat');
  delete_option('dkret_limitarchiv');
  delete_option('dkret_about');
  delete_option('dkret_ajaxcomments');
  		
	// Flush the dang cache
	wp_cache_flush();

	// Activate the default Wordpress theme so as not to re-install dKret2
	update_option('template', 'default');
	update_option('stylesheet', 'default');
	do_action('switch_theme', 'Default');
	exit;
}

// Let's add the options page.
add_action ('admin_menu', 'dkretmenu');

$dkretloc = '../themes/' . basename(dirname($file)); 

function dkretmenu() {
	add_submenu_page('themes.php', 'dKret2 Options', __('dKret2 Options','dkret') , 5, $dkretloc . 'functions.php', 'menu');
}

function menu() {
  global $wp_version;

  if (isset($_POST['Submit'])) : ?>
    <div class="updated">
  		<p><?php _e('Options saved','dkret'); ?></p>
  	</div>
  <?php endif; ?>
  
  <?php if (isset($_POST['uninstall'])) : ?> 
  	<div class="updated">
  		<p><?php _e('dKret2 uninstalled','dkret'); ?></p>
  	</div>
  	<?php dkretuninstall();
  endif; ?>

  <?php if (WPLANG=='') : ?>
  	<div class="error">
  		<h1>YOU HAVEN'T CONFIGURED YOUR BLOG LANGUAGE IN wp-config.php YET! LOCALIZATION WON'T WORK WITHOUT SETTING YOUR LOCALE!</h1>
  	</div>
  <?php endif; ?>

  <?php if ($wp_version < '2.2') { ?>
  	<div class="error">
  		<h1><?php _e('DKret2 2.4 requires Wordpress 2.2 or higher!','dkret'); ?></h1>
  	</div>
  <?php } ?>

	<?php if (dkret_version_check()) { ?>
    <div class="error">
      <p><?php _e('A new version of dKret2 is available. Please visit the dKret2 page for more informations.','dkret'); ?></p>
    </div>
  <?php } ?>

  <?php if (!exist_active_widgets()) { ?>
    <div class="updated">
      <h1><a href='<?php bloginfo('url'); ?>/wp-admin/widgets.php'><?php _e("Don't forget to add Widgets to your Sidebars!",'dkret'); ?></a></h1>
    </div>
  <?php } ?>
  
  <?php if (get_option('dkret_installed') < DKRETVERSION) { ?>
    <div class="error">
      <p><?php _e('You have installed a new version of dKret2 without uninstalling the old one first!<br />Uninstall dKret2 at the bottom of this page and acitivate it again.','dkret'); ?></p>
    </div>
  <?php } ?>

  <div class="wrap">
    <div class="configstuff">
    <h2><?php _e('dKret2 Options','dkret'); ?></h2>

    <p>
      <span style="float: right;"><?php _e('Version:','dkret'); ?> <strong><?php dkretinfo(version) ?></strong></span>
      <?php _e('Developed by','dkret'); ?> J. Kretzschmar.<br />
      <?php _e('Visit <a href="http://diekretzschmars.de/dkret-theme/">diekretzschmars.de</a> for updates.','dkret'); ?>
    </p>

   	<div class="using_schemes">
  			<h3><?php _e('Schemes','dkret'); ?></h3>
  			<p><small><?php _e("DKret schemes are CSS files that allow you to visually customize your blog, without ever touching dkret2's core files.<br />Rename your old <strong>style-user.css</strong> (leave css extension) and copy it to the schemes directory in the dKret2 folder.",'dkret'); ?></small></p>
  	</div>
    
	<script type="text/javascript">
    var blogadress = "<?php echo get_template(); ?>";
  	function updateHeader(sel) {
    	if (sel.options[sel.selectedIndex].value == "dKret2") {
        document.header.src = "../wp-content/themes/" + blogadress + "/images/bg_header_grass.jpg";
    	}	else {
        document.header.src = "../wp-content/themes/" + blogadress + "/images/headers/" + sel.options[sel.selectedIndex].value;
    	}
  	}
	</script>

    <form name="dofollow" action="" method="post" enctype="multipart/form-data">
      <input type="hidden" name="action" value="<?php dkretupdate(); ?>" />
      <input type="hidden" name="page_options" value="'dofollow_timeout'" />

			<?php
			global $wpdb;
			$name = get_option('dkret_scheme');
			if ($name != '') {
				$scheme_title = $name;
			} else {
				$scheme_title ='dKret2';
			}
			?>

      <p>    
  			<select name="scheme_file" id="scheme_file" style="width: 65%;">
  			<option value="<?php echo get_option('dkret_scheme'); ?>"><?php echo $scheme_title; ?></option>
  			<option value=""> ------ </option>
  			<option value=""><?php _e('Use Standard dKret2 Scheme','dkret') ?></option>
  
  			<?php
  			$scheme_dir = @ dir(ABSPATH . '/wp-content/themes/' . get_template() . '/schemes');
  
  			if ($scheme_dir) {
  				while(($file = $scheme_dir->read()) !== false) {
  			  		if (!preg_match('|^\.+$|', $file) && preg_match('|\.css$|', $file)) 
  						$scheme_files[] = $file;
  					}
  				}
  				if ($scheme_dir || $scheme_files) {
  					foreach($scheme_files as $scheme_file) {
  				 	echo '<option value="' . $scheme_file . '">' . $scheme_file . '</option>';
  				}
  				echo '</select>';
  			} 
  			?>
      </p>

    	<div class="changing_header">
    			<h3><?php _e('Header Settings','dkret'); ?></h3>
    	</div>

  		<p><small><?php _e("Choose the picture you would like to upload to the server and you are done. To fill the header area completely you should make the image <strong>900</strong> pixels wide by <strong>160</strong> pixels high.<br />You can even upload multiple files and randomly circle through them if you enable <strong>'Show Random Header Picture.'</strong>",'dkret'); ?></small></p>
  		<p><input size="30" type="file" name="picture" /></p>

  		<p><small><?php _e('Please select the picture you want to show at the frontpage from the dropdown field below.','dkret'); ?></small></p>

  		<?php
  		global $wpdb;
  		$picname = get_option('dkret_header_picture');
     
  		if ($picname != '')	{
  			$picture_title = $picname;
  		}	else {
  			$picture_title = __('Standard Header Image','dkret');
  		}

  		if ($picname != 'dKret2') {
  			$pic = '../wp-content/themes/' . get_template() . '/images/headers/'.$picture_title;
  		}	else {
  			$pic = '../wp-content/themes/' . get_template() . '/images/bg_header_grass.jpg';
  		}
  		echo ('<p><img name="header" src="'.$pic.'" width="65%" alt=""></img></p>');
  		?>

      <p>
  		<select style="width: 65%;" name="header_picture" onchange="updateHeader( this )">
    		<option value="<?php echo get_option('dkret_header_picture')?>"><?php echo $picture_title; ?></option>
    		<option value=""> ------ </option>
    		<option value="dKret2"><?php _e('Standard Header Image','dkret'); ?></option>
    			<?php
    			$picture_dir = @ dir(ABSPATH . '/wp-content/themes/' . get_template() . '/images/headers');
    			if ($picture_dir)	{
				
    				while(($file = $picture_dir->read()) !== false)	{

     					if (!preg_match('|^\.+$|', $file) && !preg_match('|^CVS$|', $file) && preg_match('/\.(gif|jpg|png)$/i',$file))	{
    						$picture_files[] = $file;
    					}
    				}
    				if ($picture_dir || $picture_files)	{
    					foreach ($picture_files as $picture_file) {
    						echo "<option value=\"".$picture_file."\">".$picture_file."</option>";
    					}
    				}
    			}	?>
  		  </select>
      </p>

  		<p><input type="checkbox" name="userandomfeature" value="1" <?php checked('1', get_option('dkret_imagerandomfeature')); ?> /> <?php _e('Show Random Header Picture','dkret'); ?></p>

      <p>
   			<input name="header_text" id="show_title" type="checkbox" value="1" <?php checked('1', get_option('dkret_header_text')); ?> /> <?php _e('Show Title','dkret') ?><br />
        <?php if (function_exists ('library_url')) { ?>
          <input name="nowreading" id="nowreading" type="checkbox" value="1" <?php checked('1', get_option('dkret_nowreading')); ?> /> <?php _e('Show Now Reading Link','dkret') ?><br />
        <?php } ?>
      </p>

  		<p><small><?php _e("Choose number of levels you want to show in your top navigation.<br /><b>Add Subnavigation Widget so everybody (even without javascript) can access your site</b>.",'dkret'); ?></small></p>

      <p>
    		<select style="width: 65%;" name="show_subnavigation" id="show_subnavigation">
      		<option value="<?php echo get_option('dkret_header_subnavigation')?>">
            <?php $level = get_option('dkret_header_subnavigation');
              $messages[1] = __('Show top-level links only', 'dkret');
              $messages[2] = __('Show first sub-level', 'dkret');
              $messages[3] = __('Show second sub-level', 'dkret');
              $messages[4] = __('Show third sub-level', 'dkret');
              echo $messages[$level]; 
            ?>
          </option>
      		<option value=""> ------ </option>
      		<option value="1"><?php echo $messages[1] ?></option>
      		<option value="2"><?php echo $messages[2] ?></option>
      		<option value="3"><?php echo $messages[3] ?></option>
      		<option value="4"><?php echo $messages[4] ?></option>
        </select>
      </p>
  
    	<div class="changing_comments">
    			<h3><?php _e('Comments','dkret'); ?></h3>
    	</div>

      <p><small><?php _e("DKret2 uses AJAX to submit comments without reloading the page. Live Commenting is based on 'jQuery AJAX Comments'.",'dkret') ?></small></p>

 			<p>
 			  <input name="separatecomments" id="separatecomments" type="checkbox" value="1" <?php checked('1', get_option('dkret_separatecomments')); ?> /> <?php _e('Separate Trackbacks from Comments','dkret') ?><br />
        <?php if (!function_exists('gravatar')) { ?>
 			    <input name="showgravatars" id="showgravatars" type="checkbox" value="1" <?php checked('1', get_option('dkret_showgravatars')); ?> /> <?php _e('Show Gravatars','dkret') ?>
        <?php } ?>
      </p>

      <p>
   			<input name="commentsorder" id="new-comments" type="radio" value="0" <?php checked('0', get_option('dkret_commentsorder')); ?> /> <?php _e('Show new comments first','dkret') ?><br />
   			<input name="commentsorder" id="old-comments" type="radio" value="1" <?php checked('1', get_option('dkret_commentsorder')); ?> /> <?php _e('Show old comments first','dkret') ?>
      </p>
  
      <p>
   			<input name="limitcomments" id="limitcomments" type="text" value="<?php echo get_option('dkret_limitcomments'); ?>" size="2" /><br /> 
        <small><?php _e('Limits the number of comments shown. Set to 0 for no limit (default).','dkret') ?><br />
        <strong><?php _e("Requires 'Show new comments first'.",'dkret') ?></strong></small>
      </p>

    	<div class="changing_blog_settings">
    			<h3><?php _e('Blog Settings','dkret'); ?></h3>
    	</div>

      <p>
        <input name="thickbox" id="thickbox" type="checkbox" value="1" <?php checked('1', get_option('dkret_thickbox')); ?> /> <?php _e('Use Thickbox for Images','dkret') ?><br />
      </p>

    	<p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options','dkret') ?> &raquo;" /></p>
  
    	<div class="configstuff">
  			<h3><?php _e('Uninstall dKret2','dkret'); ?></h3>
  			<p><small><?php _e('Pressing the uninstall button does not delete any files. It simply disables dKret2 as a theme, reverting to the default theme, and removes all the dKret2 settings from the database. Perfect for if you want to start afresh.','dkret'); ?></small></p>
  			<p style="text-align: center;"><input id="uninstall" name="uninstall" type="submit" value="<?php _e('Reset and Uninstall dKret2','dkret'); ?>" /></p>
      </div>
    
    </form>

    </div>

  </div>

  <div class="wrap">
  	<p style="text-align: center;"><?php _e('Help to be had at the <a href="http://diekretzschmars.de/dkret-theme/forum/" title="dKret2 Support Forum">dKret2 Support Forum</a> or in the <a href="http://diekretzschmars.de/dkret-theme/documentation/" title="Documentation">dKret2 Documentation</a>.','dkret') ?></p>
  	<p style="text-align: center;"><?php _e('Theme-Options inspired by <a href="http://binarybonsai.com/wordpress/k2/">K2</a> (beta2)','dkret') ?></p>
  </div>


<?php } // this ends the admin page ?>
